check-lxdialog.sh 1.7 KB
Newer Older
1 2 3 4 5 6
#!/bin/sh
# Check ncurses compatibility

# What library to link
ldflags()
{
7
	for ext in so a dll.a dylib ; do
8 9 10 11 12 13 14 15
		for lib in ncursesw ncurses curses ; do
			$cc -print-file-name=lib${lib}.${ext} | grep -q /
			if [ $? -eq 0 ]; then
				echo "-l${lib}"
				exit
			fi
		done
	done
16
	exit 1
17 18 19 20 21
}

# Where is ncurses.h?
ccflags()
{
22 23 24
	if [ -f /usr/include/ncursesw/curses.h ]; then
		echo '-I/usr/include/ncursesw -DCURSES_LOC="<ncursesw/curses.h>"'
	elif [ -f /usr/include/ncurses/ncurses.h ]; then
25 26 27 28 29 30 31 32 33 34
		echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
	elif [ -f /usr/include/ncurses/curses.h ]; then
		echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"'
	elif [ -f /usr/include/ncurses.h ]; then
		echo '-DCURSES_LOC="<ncurses.h>"'
	else
		echo '-DCURSES_LOC="<curses.h>"'
	fi
}

S
Sam Ravnborg 已提交
35 36 37 38
# Temp file, try to clean up after us
tmp=.lxdialog.tmp
trap "rm -f $tmp" 0 1 2 3 15

39 40
# Check if we can link to ncurses
check() {
41 42 43 44
        $cc -xc - -o $tmp 2>/dev/null <<'EOF'
#include CURSES_LOC
main() {}
EOF
45
	if [ $? != 0 ]; then
46 47 48 49 50 51 52
	    echo " *** Unable to find the ncurses libraries or the"       1>&2
	    echo " *** required header files."                            1>&2
	    echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
	    echo " *** "                                                  1>&2
	    echo " *** Install ncurses (ncurses-devel) and try again."    1>&2
	    echo " *** "                                                  1>&2
	    exit 1
53 54 55 56
	fi
}

usage() {
57
	printf "Usage: $0 [-check compiler options|-ccflags|-ldflags compiler options]\n"
58 59
}

60
if [ $# -eq 0 ]; then
61 62 63 64
	usage
	exit 1
fi

S
Sam Ravnborg 已提交
65
cc=""
66 67 68
case "$1" in
	"-check")
		shift
69
		cc="$@"
70 71 72 73 74 75
		check
		;;
	"-ccflags")
		ccflags
		;;
	"-ldflags")
76 77
		shift
		cc="$@"
78 79 80 81 82 83 84
		ldflags
		;;
	"*")
		usage
		exit 1
		;;
esac